Index: DCWoRMS/branches/coolemall/src/simulator/workload/WorkloadLoader.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/workload/WorkloadLoader.java	(revision 1170)
+++ DCWoRMS/branches/coolemall/src/simulator/workload/WorkloadLoader.java	(revision 1207)
@@ -17,4 +17,5 @@
 import javax.xml.xpath.XPathExpressionException;
 
+import org.apache.commons.io.FilenameUtils;
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
@@ -32,4 +33,5 @@
 import simulator.workload.reader.archive.swf.SWFFields;
 import simulator.workload.reader.xmlJob.XMLJobReader;
+import dcworms.schedframe.scheduling.utils.ApplicationProfileDescription;
 import dcworms.schedframe.scheduling.utils.JobDescription;
 import dcworms.schedframe.scheduling.utils.TaskDescription;
@@ -56,7 +58,9 @@
 	
 	protected Map<String, JobDescription> jobsMap;
-	protected Map<String, JobDescription> applicationProfilesMap;
-
-	public WorkloadLoader(XMLJobReader<org.qcg.broker.schemas.jobdesc.Job> xmlReader, WAReader<org.qcg.broker.schemas.jobdesc.Job> swfReader){
+	
+	protected String appProfilesFolder;
+	protected Map<String, ApplicationProfileDescription> applicationProfiles;
+
+	public WorkloadLoader(XMLJobReader<org.qcg.broker.schemas.jobdesc.Job> xmlReader, WAReader<org.qcg.broker.schemas.jobdesc.Job> swfReader, String appProfilesFolder){
 		if(swfReader == null){
 			throw new RuntimeException("Swf reader is required to build proper tasks.");
@@ -67,5 +71,6 @@
 		this.generatedTasksCnt = 0;
 		this.jobsMap = new TreeMap<String, JobDescription>();
-		this.applicationProfilesMap = new TreeMap<String, JobDescription>();
+		this.appProfilesFolder = appProfilesFolder;
+		this.applicationProfiles = new TreeMap<String, ApplicationProfileDescription>();
 		try {
 			this.xsltTransformation = new XsltTransformations();
@@ -187,55 +192,30 @@
 
 		// determine which reader should be used
-		String jobDesc = null;
-		JobDescription job = null;
-			
+		String xmlJob = null;
+		JobDescription jobDesc = null;
+			
+		for(String key: waReader.getParser().getAppProfilesLocation().keySet()){
+			String xmlApp = loadApplicationProfile(waReader.getParser().getAppProfilesLocation().get(key));
+			xmlApp = this.xsltTransformation.extendJobDescription(xmlApp);
+			ApplicationProfileDescription app = this.xsltTransformation.getApplicationProfileDescription(xmlApp);
+			this.applicationProfiles.put(key, app);
+		}
+		
 		if(this.xmlJobReader != null){ // use xml job reader. Xml job require xslt transformation
-			while((jobDesc = this.xmlJobReader.readRaw()) != null){
-				jobDesc = this.xsltTransformation.extendJobDescription(jobDesc);
-				job = createJobDescription(jobDesc, puSpeed);
-				if(job != null)
-					this.jobsMap.put(job.getJobId(), job);
+			while((xmlJob = this.xmlJobReader.readRaw()) != null){
+				xmlJob = this.xsltTransformation.extendJobDescription(xmlJob);
+				jobDesc = createJobDescription(xmlJob, puSpeed);
+				if(jobDesc != null)
+					this.jobsMap.put(jobDesc.getJobId(), jobDesc);
 			}
 		} else {						// use swf job reader. Job created by this reader does not require xslt transformation
 			
-			for(String key: waReader.getParser().getAppMapping().keySet()){
-				jobDesc = loadApplicationProfile(waReader.getParser().getAppMapping().get(key));
-				jobDesc = this.xsltTransformation.extendJobDescription(jobDesc);
-					
-				try {
-					job = this.xsltTransformation.splitJobToTasks(jobDesc);
-				} catch (Exception e) {
-					throw new IOException(e.getMessage());
-				}
-				
-				this.applicationProfilesMap.put(key, job);
-			}
-			
-			while((jobDesc = this.waReader.readRaw()) != null){
+			while((xmlJob = this.waReader.readRaw()) != null){
 				QcgWAJobReader qcgReader = (QcgWAJobReader)waReader;
-				if(!applicationProfilesMap.isEmpty())
-					jobDesc = qcgReader.mergeSwfAndXmlProfile(applicationProfilesMap, jobDesc);
-				job = createJobDescription(jobDesc, puSpeed);
-				/*if(job!= null && !applicationProfilesMap.isEmpty()){
-					for(int i = 0; i < job.getDescription().getTaskCount(); i++){
-						try {
-							JobDescription xmlJobDescription = applicationProfilesMap.get(job.getDescription().getTask(i).getExecution().getExecutable().getApplication().getAppProperty(0).getContent());
-							if(xmlJobDescription != null){
-								for(int j = 0; j < xmlJobDescription.size(); j++){
-									Task patternTask = xmlJobDescription.getDescription().getTask(j);
-									if(patternTask != null){
-										ResourceConsumptionProfileType rcp = patternTask.getExecution().getResourceConsumptionProfile();
-										job.getDescription().getTask(j).getExecution().setResourceConsumptionProfile(rcp);
-									}
-								}
-							}	
-						} catch (Exception e){
-							continue;
-						}
-					}					
-				}
-				*/
-				if(job != null)
-					this.jobsMap.put(job.getJobId(), job);
+				if(!applicationProfiles.isEmpty())
+					xmlJob = qcgReader.mergeSwfAndAppProfile(applicationProfiles, xmlJob);
+				jobDesc = createJobDescription(xmlJob, puSpeed);
+				if(jobDesc != null)
+					this.jobsMap.put(jobDesc.getJobId(), jobDesc);
 			}
 		}
@@ -302,11 +282,20 @@
 	}
 
-	public String loadApplicationProfile(String fileName) throws IOException{
+	public String loadApplicationProfile(String pathToAppProfile) throws IOException{
 		
 		BufferedReader reader = null;
 		StringBuffer buffer = new StringBuffer();
 
-		try {
-			reader = new BufferedReader(new FileReader(fileName));
+		String localPathToAppProfile;
+		
+		if(appProfilesFolder != null) {
+			String folderName = FilenameUtils.getFullPath(appProfilesFolder);
+			String fileName = FilenameUtils.getName(pathToAppProfile);
+			localPathToAppProfile = folderName + fileName;
+		} else {
+			localPathToAppProfile = pathToAppProfile;
+		}
+		try {
+			reader = new BufferedReader(new FileReader(localPathToAppProfile ));
 			String line = null;
 			
Index: DCWoRMS/branches/coolemall/src/simulator/ConfigurationOptions.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/ConfigurationOptions.java	(revision 802)
+++ DCWoRMS/branches/coolemall/src/simulator/ConfigurationOptions.java	(revision 1207)
@@ -52,5 +52,6 @@
 	public static final String READ_SCENARIO_INPUT_FOLDER = READ_SCENARIO_MODIFIER
 			+ ".inputfolder";
-	
+	/** The input folder with application profiles */
+	public static final String READ_SCENARIO_APPLCIATION_PROFILES = READ_SCENARIO_MODIFIER + ".applicationProfiles";
 	/** The name of the workload file */
 	public static final String READ_SCENARIO_WORKLOAD_FILE = READ_SCENARIO_MODIFIER
@@ -79,8 +80,12 @@
 	public static final String JOBS_STATISTICS = CREATESTATISTICS + ".jobs";
 	public static final String SIMULATION_STATISTICS = CREATESTATISTICS + ".simulation";
-	
-	public static final String COOLEMALL = "coolemall";
-	public static final String COOLEMALL_RESOURCE = COOLEMALL + ".resdesc";
-
+
+	public static final String PRESSURE_DROP = "pressuredrop";
+	public static final String OUTLET_ROOM_AIR_TEMPERATURE = "outletroomairtemperature";
+	public static final String INLET_ROOM_AIR_TEMPERATURE = "inletroomairtemperature";
+	public static final String AMBIENT_AIR_TEMPERATURE = "ambientairtemperature";
+	public static final String AIR_FLOW_VOLUME = "airflowvolume";
+	public static final String ALPHA = "alpha";
+	
 	/**
 	 * The main output folders base name
@@ -101,5 +106,5 @@
 	 * Suffix for read scenario output folder
 	 */
-	public String statsOutputSubfolderNameRerad = null;
+	public String statsOutputSubfolderNameRead = null;
 	
 	/* =============================================================================================== */
@@ -137,4 +142,6 @@
 	 */
 	public String inputFolder = null;
+	
+	public String appProfilesFolder = null;
 	
 	public String inputTar = null;
@@ -184,6 +191,11 @@
 	public String [] resForUtilizationChart;
 	
-	public String coolEmAllResdescFileName = null;
-
+	public static double pressureDrop;
+	public static double outletRoomAirTempeature;
+	public static double inletRoomAirTempeature;
+	public static double ambientAirTempeature;
+	public static double airFlowVolume;
+	public static double alpha
+	;
 	/**
 	 * An empty constructor.
@@ -255,4 +267,11 @@
 			
 			try {
+				co.appProfilesFolder  = getSeparatorTerminatedPath(bundle
+					.getString(READ_SCENARIO_APPLCIATION_PROFILES));
+			} catch (MissingResourceException e) {
+				co.appProfilesFolder  = null;
+			}
+			
+			try {
 				co.inputWorkloadFileName = bundle
 						.getString(READ_SCENARIO_WORKLOAD_FILE);
@@ -346,8 +365,8 @@
 		try {
 			co.statsOutputSubfolderNameCreate = bundle.getString(STATS_OUTPUT_SUBFOLDER_NAME);
-			co.statsOutputSubfolderNameRerad = co.statsOutputSubfolderNameCreate;
+			co.statsOutputSubfolderNameRead = co.statsOutputSubfolderNameCreate;
 		} catch(MissingResourceException e){
 			co.statsOutputSubfolderNameCreate = "stats_create";
-			co.statsOutputSubfolderNameRerad = "stats_read";
+			co.statsOutputSubfolderNameRead = "stats_read";
 		}
 
@@ -370,11 +389,41 @@
 			co.numberOfSimulations = 1;
 		}
-		
-		try {
-			co.coolEmAllResdescFileName = bundle.getString(COOLEMALL_RESOURCE);
-			System.setProperty("coolemall.resdesc", co.coolEmAllResdescFileName);
-		} catch(MissingResourceException e){
-			co.coolEmAllResdescFileName = null;
-		}
+
+		try {
+			ConfigurationOptions.pressureDrop = Double.valueOf(bundle.getString(PRESSURE_DROP)).doubleValue();
+		} catch(MissingResourceException e){
+			ConfigurationOptions.pressureDrop = 175.337;
+		}
+		
+		try {
+			ConfigurationOptions.outletRoomAirTempeature = Double.valueOf(bundle.getString(OUTLET_ROOM_AIR_TEMPERATURE)).doubleValue();
+		} catch(MissingResourceException e){
+			ConfigurationOptions.outletRoomAirTempeature = 23;
+		}
+		
+		try {
+			ConfigurationOptions.inletRoomAirTempeature = Double.valueOf(bundle.getString(INLET_ROOM_AIR_TEMPERATURE)).doubleValue();
+		} catch(MissingResourceException e){
+			ConfigurationOptions.inletRoomAirTempeature = 17;
+		}
+		
+		try {
+			ConfigurationOptions.ambientAirTempeature = Double.valueOf(bundle.getString(AMBIENT_AIR_TEMPERATURE)).doubleValue();
+		} catch(MissingResourceException e){
+			ConfigurationOptions.ambientAirTempeature = 17;
+		}
+		
+		try {
+			ConfigurationOptions.airFlowVolume = Double.valueOf(bundle.getString(AIR_FLOW_VOLUME)).doubleValue();
+		} catch(MissingResourceException e){
+			ConfigurationOptions.airFlowVolume = 0.304;
+		}
+		
+		try {
+			ConfigurationOptions.alpha = Double.valueOf(bundle.getString(ALPHA)).doubleValue();
+		} catch(MissingResourceException e){
+			ConfigurationOptions.alpha = 0.02;
+		}
+		
 		return co;
 	}
Index: DCWoRMS/branches/coolemall/src/simulator/DataCenterWorkloadSimulator.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/DataCenterWorkloadSimulator.java	(revision 1142)
+++ DCWoRMS/branches/coolemall/src/simulator/DataCenterWorkloadSimulator.java	(revision 1207)
@@ -14,4 +14,5 @@
 import javax.swing.filechooser.FileFilter;
 
+import org.apache.commons.io.FilenameUtils;
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
@@ -21,5 +22,5 @@
 
 import schedframe.Initializable;
-import schedframe.ResourceController;
+import schedframe.SimulatedEnvironment;
 import simulator.reader.ResourceReader;
 import simulator.stats.AccumulatedStatistics;
@@ -51,5 +52,10 @@
 	 * The name of the simulator application
 	 */
-	public static final String SIMULATOR_NAME = "Data Center Workload Simulator";
+	public static final String SIMULATOR_NAME = "Data Center Workload and Resource Management Simulator";
+	
+	/**
+	 * The simulation mode
+	 */
+	public static String MODE = "Standard";
 
 	/**
@@ -183,7 +189,9 @@
 		}
 
-		if (log.isInfoEnabled())
+		if (log.isInfoEnabled()){
 			log.info("Done :: " + SIMULATOR_NAME + " has finished "
 					+ noOfSimulations + " simulation runs ::");
+			log.info("Simulation finished with status: 0");
+		}
 
 		System.out.flush();
@@ -259,6 +267,6 @@
 
 		ResourceReader resourceReader = new ResourceReader(
-				options);
-		ResourceController rc = resourceReader.read();
+				options.resdescFileName);
+		SimulatedEnvironment rc = resourceReader.read();
 		eventManager = new EventManager("eventManager", rc);
 		
@@ -268,12 +276,16 @@
 		rc.setInitList(null);
 		
-		DCWormsUsers wl = new DCWormsUsers("Users",
+		DCWormsUsers users = new DCWormsUsers("Users",
 				rc.getScheduler().get_name(), workload);
 		
+		System.out.println("Starting simulation...");
+
 		GridSimWrapper.startSimulation();
 		long stopSimulation = System.currentTimeMillis();
 
+		System.out.println("Simulation finished");
+
 		DCWormsStatistics stats = new DCWormsStatistics(simulationIdentifier,
-				options, wl, statsOutputPath, rc);
+				options, users, statsOutputPath, rc);
 		accumulatedStatistics.add(stats);
 		if (log.isInfoEnabled())
@@ -301,4 +313,5 @@
 		String wlFileName = options.inputWorkloadFileName;
 
+		String appProfilesFolder = options.appProfilesFolder;
 		if (options.inputFolder != null) {
 			File f = null;
@@ -318,5 +331,5 @@
 		swfReader = AbstractWAReader.getInstace(wlFileName);
 
-		WorkloadLoader workload = new WorkloadLoader(xmlJobReader, swfReader);
+		WorkloadLoader workload = new WorkloadLoader(xmlJobReader, swfReader, appProfilesFolder);
 		workload.load();
 
@@ -346,10 +359,11 @@
 				prefix = options.inputFolder;
 			} else if (options.inputWorkloadFileName != null) {
-				prefix = new File(options.inputWorkloadFileName).getParent();
+				prefix = FilenameUtils.getFullPath(new File(options.inputWorkloadFileName).getAbsolutePath());
 			} else {
 				prefix = System.getProperty("user.dir");
 			}
-			statsOutputPath = prefix + File.separator
-					+ options.statsOutputSubfolderNameRerad;
+			//statsOutputPath = prefix + File.separator
+			//		+ options.statsOutputSubfolderNameRead;
+			statsOutputPath = options.statsOutputSubfolderNameRead;
 		}
 		statsOutputPath += File.separator;
Index: DCWoRMS/branches/coolemall/src/simulator/stats/MetricsCalculator.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/MetricsCalculator.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/MetricsCalculator.java	(revision 1207)
@@ -0,0 +1,455 @@
+package simulator.stats;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import simulator.stats.implementation.MetricsStats;
+import example.energy.coolemall.CoolEmAllTestbedMeasurements;
+
+public class MetricsCalculator {
+	
+	protected static final double MILLI_SEC = 1000;
+	protected static final double SEC_IN_HOUR = 3600;
+	
+	protected Map<String, List<GSSAccumulator>> metricsData = new HashMap<String, List<GSSAccumulator>>();
+	protected long timestamp;
+	protected long startTime;
+	protected long endTime;
+
+	public List<MetricsStats> calulateMetrics(long timestamp){
+		this.timestamp = timestamp;
+		List<MetricsStats> metrics = new ArrayList<MetricsStats>();
+		/*for(String resourceTypeName: metricsData.keySet()){
+			MetricsStats metric = new MetricsStats(resourceTypeName, "energyUsage", metricsData.get(resourceTypeName).getMax());
+			metrics.add(metric);}
+		}*/
+		metrics.add(calculateITComputingEnergyConsumption());
+		metrics.add(calculateITEnergyConsumption());
+		metrics.add(calculateNodeGroupFansEnergyConsumption());
+		
+		metrics.add(calculateRackEnergyConsumption());
+		metrics.add(calculateDataCenterFansEnergyConsumption());
+		metrics.add(calculateCoolingDeviceEnergyConsumption());
+		metrics.add(calculateOtherDevicesEnergyConsumption());
+		
+		metrics.add(calculateTotalEnergyConsumption());
+		
+		metrics.add(calculateMeanRackPower());
+		metrics.add(calculateMeanPower());
+		metrics.add(calculateMaxRackPower());
+		metrics.add(calculateMaxPower());
+		
+		metrics.add(calculatePUE());
+		metrics.add(calculatePUELevel4());
+		metrics.add(calculateEnergyWasteRate());
+		
+		metrics.add(calculateUsefulWork());
+		metrics.add(calculateProductivity());
+
+		return metrics;
+	}
+	
+	public void addMetricsData(String resourceTypeName, GSSAccumulator resourceEnergyAccumulator){
+		List<GSSAccumulator> resourceEnergyAccumulatorList = metricsData.get(resourceTypeName);
+		if(resourceEnergyAccumulatorList == null){
+			resourceEnergyAccumulatorList = new ArrayList<GSSAccumulator>();
+		}
+		resourceEnergyAccumulatorList.add(resourceEnergyAccumulator);
+		metricsData.put(resourceTypeName, resourceEnergyAccumulatorList);
+	}
+	
+	public Map<String, List<GSSAccumulator>> getMetricsData(){
+		return metricsData;
+	}
+	
+	private MetricsStats calculateTotalEnergyConsumption(){
+		
+		MetricsStats metric;
+		try{
+			
+			double roomPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Room")){
+				roomPower = roomPower + acc.getSum();
+			}
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_energy_consumption", roomPower, timestamp, "Wh");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_energy_consumption", -1, timestamp, "Wh");
+		}
+		return metric;
+	}
+	
+	private MetricsStats calculateITComputingEnergyConsumption(){
+		
+		MetricsStats metric;
+		try{
+			double itComputingPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Processor")){
+				itComputingPower = itComputingPower + acc.getSum();
+			}
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_processors_energy_consumption", (itComputingPower), timestamp, "Wh");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_processors_energy_consumption", -1, timestamp, "Wh");
+		}
+		return metric;
+	}
+	
+	private MetricsStats calculateITEnergyConsumption(){
+		
+		MetricsStats metric;
+		try{
+			double totalSitePower = 0; 
+			for(GSSAccumulator acc: metricsData.get("Rack")){
+				totalSitePower = totalSitePower + acc.getSum();
+			}
+			double nodeComputingPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Node")){
+				nodeComputingPower = nodeComputingPower+ acc.getSum();
+			}
+			double itComputingPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Processor")){
+				itComputingPower = itComputingPower + acc.getSum();
+			}
+			double fanPowerConumspion = nodeComputingPower - itComputingPower;
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_IT_energy_consumption", (totalSitePower * CoolEmAllTestbedMeasurements.POWER_SUPPLY_EFFICIENCY - fanPowerConumspion), timestamp, "Wh");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_IT_energy_consumption", -1, timestamp, "Wh");
+		}
+		return metric;
+	}
+	
+	private MetricsStats calculateNodeGroupFansEnergyConsumption(){
+		
+		MetricsStats metric;
+		try{
+			double nodeComputingPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Node")){
+				nodeComputingPower = nodeComputingPower+ acc.getSum();
+			}
+			double itComputingPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Processor")){
+				itComputingPower = itComputingPower + acc.getSum();
+			}
+			double nodeGroupFansPowerConumspion = nodeComputingPower - itComputingPower;
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_node_group_fans_energy_consumption", nodeGroupFansPowerConumspion, timestamp, "Wh");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_node_group_fans_energy_consumption", -1, timestamp, "Wh");
+		}
+		return metric;
+	}
+	
+	private MetricsStats calculatePUELevel4(){
+		
+		MetricsStats metric;
+		try{
+			
+			double roomPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Room")){
+				roomPower = roomPower + acc.getSum();
+			}
+			
+			double totalSitePower = 0;
+			for(GSSAccumulator acc: metricsData.get("Rack")){
+				totalSitePower = totalSitePower + acc.getSum();
+			}
+			
+		
+			double nodeComputingPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Node")){
+				nodeComputingPower = nodeComputingPower+ acc.getSum();
+			}
+			double itComputingPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Processor")){
+				itComputingPower = itComputingPower + acc.getSum();
+			}
+			double nodeGroupFansPowerConumspion = nodeComputingPower - itComputingPower;
+
+			metric = new MetricsStats("CoolEmAllTestbed", "PUE_Level_4", roomPower/(totalSitePower * CoolEmAllTestbedMeasurements.POWER_SUPPLY_EFFICIENCY - nodeGroupFansPowerConumspion), timestamp, "");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "PUE_Level_4", -1, timestamp, "");
+		}
+		return metric;
+	}
+	
+	private MetricsStats calculatePUE(){
+		
+		MetricsStats metric;
+		try{
+			
+			double roomPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Room")){
+				roomPower = roomPower + acc.getSum();
+			}
+			
+			double totalSitePower = 0;
+			for(GSSAccumulator acc: metricsData.get("Rack")){
+				totalSitePower = totalSitePower + acc.getSum();
+			}
+
+
+			metric = new MetricsStats("CoolEmAllTestbed", "PUE", roomPower/totalSitePower, timestamp, "");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "PUE", -1, timestamp, "");
+		}
+		return metric;
+	}
+
+	private MetricsStats calculateUsefulWork(){
+		
+		MetricsStats metric;
+		try{
+			double usefulWork = 0;
+			for(String key: metricsData.keySet()){
+				if(key.contains("/")){
+					for(GSSAccumulator acc: metricsData.get(key)){
+						usefulWork= usefulWork + acc.getSum();
+					}
+				}
+			}
+			metric = new MetricsStats("CoolEmAllTestbed", "Useful_Work", usefulWork, timestamp, "UW units");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Useful_Work", -1, timestamp, "UW units");
+		}
+		
+		return metric;
+	}
+	
+	private MetricsStats calculateProductivity(){
+		
+		MetricsStats metric;
+		try{
+			double usefulWork = 0;
+			for(String key: metricsData.keySet()){
+				if(key.contains("/")){
+					for(GSSAccumulator acc: metricsData.get(key)){
+						usefulWork= usefulWork + acc.getSum();
+					}
+				}
+			}
+			double totalSitePower = 0; 
+			for(GSSAccumulator acc: metricsData.get("Rack")){
+				totalSitePower = totalSitePower + acc.getSum();
+			}
+			
+			metric = new MetricsStats("CoolEmAllTestbed", "Productivity", usefulWork/totalSitePower, timestamp, "UW units/Wh");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Productivity", -1, timestamp, "UW units/Wh");
+		}
+		
+		return metric;
+	}
+	
+	
+	private MetricsStats calculateMaxRackPower(){
+		
+		MetricsStats metric;
+		try{
+			double maxPower = 0;
+			
+			for(GSSAccumulator acc: metricsData.get("Rack_MAX")){
+				maxPower = maxPower + acc.getSum();
+			}
+
+			metric = new MetricsStats("CoolEmAllTestbed", "Max_rack_power", maxPower, timestamp, "W");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Max_rack_power", -1, timestamp, "W");
+		}
+		
+		return metric;
+	}
+	
+	private MetricsStats calculateMaxPower(){
+		
+		MetricsStats metric;
+		try{
+			double maxPower = 0;
+			
+			for(GSSAccumulator acc: metricsData.get("Room_MAX")){
+				maxPower = maxPower + acc.getSum();
+			}
+
+			metric = new MetricsStats("CoolEmAllTestbed", "Max_power", maxPower, timestamp, "W");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Max_power", -1, timestamp, "W");
+		}
+		
+		return metric;
+	}
+	
+	private MetricsStats calculateDataCenterFansEnergyConsumption(){
+		
+		MetricsStats metric;
+		try{
+			double inletsPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Inlet")){
+				inletsPower = inletsPower + acc.getSum();
+			}
+			
+			double outletsPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Outlet")){
+				outletsPower = outletsPower + acc.getSum();
+			}
+			
+			double nodeComputingPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Node")){
+				nodeComputingPower = nodeComputingPower+ acc.getSum();
+			}
+			double itComputingPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Processor")){
+				itComputingPower = itComputingPower + acc.getSum();
+			}
+			double nodeGroupFansPowerConumspion = nodeComputingPower - itComputingPower;
+			
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_data_center_fans_energy_consumption", (inletsPower + outletsPower - nodeGroupFansPowerConumspion), timestamp, "Wh");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_data_center_fans_energy_consumption", -1, timestamp, "Wh");
+		}
+		return metric;
+	}
+	
+	
+	private MetricsStats calculateRackEnergyConsumption(){
+		
+		MetricsStats metric;
+		try{
+			double roomPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Rack")){
+				roomPower = roomPower + acc.getSum();
+			}
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_rack_energy_consumption", roomPower, timestamp, "Wh");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_rack_device_consumption", -1, timestamp, "Wh");
+		}
+		return metric;
+	}
+	
+	private MetricsStats calculateCoolingDeviceEnergyConsumption(){
+		
+		MetricsStats metric;
+		try{
+			double coolingDevicePower = 0;
+			for(GSSAccumulator acc: metricsData.get("CoolingDevice")){
+				coolingDevicePower = coolingDevicePower + acc.getSum();
+			}
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_cooling_device_energy_consumption", coolingDevicePower, timestamp, "Wh");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_cooling_device_consumption", -1, timestamp, "Wh");
+		}
+		return metric;
+	}
+	
+	private MetricsStats calculateOtherDevicesEnergyConsumption(){
+		
+		MetricsStats metric;
+		try{
+			double roomPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Room")){
+				roomPower = roomPower + acc.getSum();
+			}
+			
+			double totalSitePower = 0;
+			for(GSSAccumulator acc: metricsData.get("Rack")){
+				totalSitePower = totalSitePower + acc.getSum();
+			}
+			
+			double coolingDevicePower = 0;
+			for(GSSAccumulator acc: metricsData.get("CoolingDevice")){
+				coolingDevicePower = coolingDevicePower + acc.getSum();
+			}
+			
+			double inletsPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Inlet")){
+				inletsPower = inletsPower + acc.getSum();
+			}
+			
+			double outletsPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Outlet")){
+				outletsPower = outletsPower + acc.getSum();
+			}
+			
+			double nodeComputingPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Node")){
+				nodeComputingPower = nodeComputingPower+ acc.getSum();
+			}
+			double itComputingPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Processor")){
+				itComputingPower = itComputingPower + acc.getSum();
+			}
+			double nodeGroupFansPowerConumspion = nodeComputingPower - itComputingPower;
+			
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_other_devices_energy_consumption", roomPower - (totalSitePower + coolingDevicePower + (inletsPower + outletsPower - nodeGroupFansPowerConumspion)), timestamp, "Wh");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Total_other_devices_consumption", -1, timestamp, "Wh");
+		}
+		return metric;
+	}
+
+	
+	private MetricsStats calculateMeanPower(){
+		
+		MetricsStats metric;
+		try{
+			
+			double roomPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Room")){
+				roomPower = roomPower + acc.getSum();
+			}
+			metric = new MetricsStats("CoolEmAllTestbed", "Mean_power", roomPower/((this.endTime - this.startTime)/(SEC_IN_HOUR * MILLI_SEC)), timestamp, "W");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Mean_power", -1, timestamp, "W");
+		}
+		return metric;
+	}
+	
+	
+	private MetricsStats calculateMeanRackPower(){
+		
+		MetricsStats metric;
+		try{
+			
+			double roomPower = 0;
+			for(GSSAccumulator acc: metricsData.get("Rack")){
+				roomPower = roomPower + acc.getSum();
+			}
+			metric = new MetricsStats("CoolEmAllTestbed", "Mean_rack_power", roomPower/((this.endTime - this.startTime)/(SEC_IN_HOUR * MILLI_SEC)), timestamp, "W");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Mean_rack_power", -1, timestamp, "W");
+		}
+		return metric;
+	}
+	
+	private MetricsStats calculateEnergyWasteRate(){
+		
+		MetricsStats metric;
+		try{
+			double itComputingEnergy = 0;
+			for(GSSAccumulator acc: metricsData.get("Processor_CALC")){
+				itComputingEnergy = itComputingEnergy + acc.getSum();
+			}
+			itComputingEnergy = itComputingEnergy + CoolEmAllTestbedMeasurements.OTHER_DEVICES_POWER_CONSUMPTION * (this.endTime - this.startTime)/(SEC_IN_HOUR * MILLI_SEC);
+			double itEnergy = calculateITEnergyConsumption().getValue();
+			
+			metric = new MetricsStats("CoolEmAllTestbed", "Energy_waste_rate", (1 - itComputingEnergy/itEnergy) * 100, timestamp, "%");
+		} catch (Exception e){
+			metric = new MetricsStats("CoolEmAllTestbed", "Energy_waste_rate", -1, timestamp, "%");
+		}
+		return metric;
+	}
+	
+	public long getStartTime() {
+		return startTime;
+	}
+
+	public void setStartTime(long startTime) {
+		this.startTime = startTime;
+	}
+
+	public long getEndTime() {
+		return endTime;
+	}
+
+	public void setEndTime(long endTime) {
+		this.endTime = endTime;
+	}
+}
Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/MetricsStats.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/MetricsStats.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/MetricsStats.java	(revision 1207)
@@ -0,0 +1,55 @@
+package simulator.stats.implementation;
+
+import simulator.stats.implementation.out.StatsSerializer;
+
+public class MetricsStats implements StatsInterface {
+
+	protected String resourceName;
+	protected String metricName;
+	protected double value;
+	protected long timestamp;
+	protected String unit;
+	
+	private String[] headers = { "resourceName", "metricName", "value" };
+	
+	public MetricsStats(String resourceName, String metricName, double value) {
+		this(resourceName, metricName, value, 0, "");
+	}
+
+	public MetricsStats(String resourceName, String metricName, double value, long timestamp, String unit) {
+		super();
+		this.resourceName = resourceName;
+		this.metricName = metricName;
+		this.value = value;
+		this.timestamp = timestamp;
+		this.unit = unit;
+	}
+	
+	public Object serialize(StatsSerializer serializer) {
+		return serializer.visit(this);
+	}
+
+	public String[] getHeaders() {
+		return headers;
+	}
+
+	public String getResourceName() {
+		return resourceName;
+	}
+
+	public String getMetricName() {
+		return metricName;
+	}
+
+	public double getValue() {
+		return value;
+	}
+
+	public long getTimestamp() {
+		return timestamp;
+	}
+
+	public String getUnit() {
+		return unit;
+	}
+}
